/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Information related to the beneficiary
 */
@ApiModel(description = "Information related to the beneficiary")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Person {
  @SerializedName("title")
  private String title = null;

  @SerializedName("first_name")
  private String firstName = null;

  @SerializedName("last_name")
  private String lastName = null;

  @SerializedName("birth_date")
  private LocalDate birthDate = null;

  @SerializedName("gender")
  private String gender = null;

  @SerializedName("nationalities")
  private Nationalities nationalities = null;

  public Person title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Civility. Expected values (MR, MS, MISS, DR, PR)
   * @return title
  **/
  @ApiModelProperty(example = "MR", value = "Civility. Expected values (MR, MS, MISS, DR, PR)")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public Person firstName(String firstName) {
    this.firstName = firstName;
    return this;
  }

   /**
   * First name
   * @return firstName
  **/
  @ApiModelProperty(example = "John", value = "First name")
  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public Person lastName(String lastName) {
    this.lastName = lastName;
    return this;
  }

   /**
   * Last name
   * @return lastName
  **/
  @ApiModelProperty(example = "Doe", required = true, value = "Last name")
  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public Person birthDate(LocalDate birthDate) {
    this.birthDate = birthDate;
    return this;
  }

   /**
   * Birth date - ISO 8601 format (YYYY-MM-DD)
   * @return birthDate
  **/
  @ApiModelProperty(example = "1989-01-01", value = "Birth date - ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getBirthDate() {
    return birthDate;
  }

  public void setBirthDate(LocalDate birthDate) {
    this.birthDate = birthDate;
  }

  public Person gender(String gender) {
    this.gender = gender;
    return this;
  }

   /**
   * Gender. Expected values (ML, FM)
   * @return gender
  **/
  @ApiModelProperty(example = "ML", value = "Gender. Expected values (ML, FM)")
  public String getGender() {
    return gender;
  }

  public void setGender(String gender) {
    this.gender = gender;
  }

  public Person nationalities(Nationalities nationalities) {
    this.nationalities = nationalities;
    return this;
  }

   /**
   * Get nationalities
   * @return nationalities
  **/
  @ApiModelProperty(value = "")
  public Nationalities getNationalities() {
    return nationalities;
  }

  public void setNationalities(Nationalities nationalities) {
    this.nationalities = nationalities;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Person person = (Person) o;
    return Objects.equals(this.title, person.title) &&
        Objects.equals(this.firstName, person.firstName) &&
        Objects.equals(this.lastName, person.lastName) &&
        Objects.equals(this.birthDate, person.birthDate) &&
        Objects.equals(this.gender, person.gender) &&
        Objects.equals(this.nationalities, person.nationalities);
  }

  @Override
  public int hashCode() {
    return Objects.hash(title, firstName, lastName, birthDate, gender, nationalities);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Person {\n");
    
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    firstName: ").append(toIndentedString(firstName)).append("\n");
    sb.append("    lastName: ").append(toIndentedString(lastName)).append("\n");
    sb.append("    birthDate: ").append(toIndentedString(birthDate)).append("\n");
    sb.append("    gender: ").append(toIndentedString(gender)).append("\n");
    sb.append("    nationalities: ").append(toIndentedString(nationalities)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

